VirtualCarGarage/VirtualCarGarage/Controllers/CarsController.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using VirtualCarGarage.Data.Models;
using VirtualCarGarage.MVC.Models;
using VirtualCarGarage.Services.Contracts;
using VirtualCarGarage.Services.Models;

namespace VirtualCarGarage.MVC.Controllers
{
    [Route("[controller]")]
    [Authorize]
    public class CarsController : Controller
    {
        private readonly ICarService carService;
        private readonly IModelService modelService;
        private readonly IUserService userService;
        private readonly UserManager<User> userManager;
        private readonly IManufacturerService manufacturerService;

        public CarsController(ICarService carService, UserManager<User> userManager, IModelService modelService, IUserService userService, IManufacturerService manufacturerService)
        {
            this.carService = carService;
            this.userManager = userManager;
            this.modelService = modelService;
            this.userService = userService;
            this.manufacturerService = manufacturerService;
        }

        [HttpGet("Index")]
        [Authorize(Roles = "Admin, Customer")]
        public async Task<IActionResult> Index()
        {
            var carDTOs = await this.carService.GetAllAsync();

            var carsView = new List<CarViewModel>();
            var user = await userManager.FindByNameAsync(User.Identity.Name);

            if (User.IsInRole("Customer"))
            {
                foreach (var item in carDTOs.Where(c => c.UserId == user.Id))
                {
                    carsView.Add(new CarViewModel
                    {
                        CarId = item.Id,
                        CarIDNumber = item.VehicleIDNumber,
                        LicensePlate = item.LicensePlate,
                        OwnerName = item.OwnerName,
                        ManufacturerId = item.ManufacturerId,
                        ModelId = item.ModelId,
                        OwnerId = item.UserId,
                        YearOfManufacture = item.YearOfManufacture
                    });
                }

                return await Task.FromResult(View(carsView));
            }


            foreach (var item in carDTOs)
            {
                carsView.Add(new CarViewModel
                {
                    CarId = item.Id,
                    CarIDNumber = item.VehicleIDNumber,
                    LicensePlate = item.LicensePlate,
                    OwnerName = item.OwnerName,
                    ManufacturerId = item.ManufacturerId,
                    ModelId = item.ModelId,
                    OwnerId = item.UserId,
                    YearOfManufacture = item.YearOfManufacture
                });
            }
            return await Task.FromResult(View(carsView));
        }

        [HttpGet("Edit/{id}")]
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Edit(int id)
        {
            var car = await this.carService.GetAsync(id);

            var carView = new CarCreateViewModel
            {
                CarId = car.Id,
                CarIDNumber = car.VehicleIDNumber,
                LicensePlate = car.LicensePlate,
                ModelId = car.ModelId,
                OwnerId = car.UserId,
                YearOfManufacture = car.YearOfManufacture,
            };

            return View(carView);

        }

        [HttpPost("Edit/{id}")]
        [ValidateAntiForgeryToken]
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Edit(CarCreateViewModel car)
        {

            if (ModelState.IsValid)
            {
                var carDTO = new CarDTO
                {
                    Id = car.CarId,
                    LicensePlate = car.LicensePlate,
                    ModelId = car.ModelId,
                    UserId = car.OwnerId,
                    VehicleIDNumber = car.CarIDNumber,
                    YearOfManufacture = car.YearOfManufacture
                };
                var updated = await carService.UpdateAsync(carDTO);
                return RedirectToAction(nameof(Index));
            }
            return View(car);
        }

        [HttpGet("Delete/{id}")]
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Delete(int id)
        {
            var car = await carService.GetAsync(id);
            var carView = new CarViewModel
            {
                CarId = car.Id,
                CarIDNumber = car.VehicleIDNumber,
                LicensePlate = car.LicensePlate,
                OwnerName = car.OwnerName,
                ManufacturerId = car.ManufacturerId,
                ModelId = car.ModelId,
                OwnerId = car.UserId,
                YearOfManufacture = car.YearOfManufacture

            };

            return View(carView);
        }

        [HttpPost("Delete/{id}")]
        [ValidateAntiForgeryToken]
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Delete(CarViewModel car)
        {
            try
            {
                var result = await carService.DeleteAsync(car.CarId);

                return RedirectToAction(nameof(Index));
            }
            catch
            {
                return View();
            }
        }

        [HttpGet("Create")]
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Create()
        {
            var models = await this.modelService.GetAllAsync();
            var modelsView = new List<ModelViewModel>();

            foreach (var item in models)
            {
                modelsView.Add(new ModelViewModel
                {
                    ModelId = item.Id,
                    ManufacturerId = item.Id,
                    Name = item.Name
                });
            }

            ViewData["ModelId"] = new SelectList(modelsView, "ModelId", "Name");


            var users = await this.userService.GetAllAsync();
            var usersView = new List<UserViewModel>();

            foreach (var user in users)
            {
                usersView.Add(new UserViewModel
                {
                    UserId = user.Id,
                    FirstName = user.FirstName,
                    LastName = user.LastName,
                    PhoneNumber = user.Phone,
                    Email = user.Email
                });
            }

            ViewData["OwnerId"] = new SelectList(usersView, "UserId", "Email");
            return View();
        }

        [HttpPost("Create")]
        [ValidateAntiForgeryToken]
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Create(CarCreateViewModel car)
        {
            if (ModelState.IsValid)
            {
                var carDTO = new CarDTO
                {
                    Id = car.CarId,
                    LicensePlate = car.LicensePlate,
                    ModelId = car.ModelId,
                    UserId = car.OwnerId,
                    VehicleIDNumber = car.CarIDNumber,
                    YearOfManufacture = car.YearOfManufacture
                };
                var created = await this.carService.CreateAsync(carDTO);
                return RedirectToAction(nameof(Index));
            }

            var models = await this.modelService.GetAllAsync();
            var modelsView = new List<ModelViewModel>();

            foreach (var item in models)
            {
                modelsView.Add(new ModelViewModel
                {
                    ManufacturerId = item.Id,
                    Name = item.Name
                });
            }

            ViewData["ModelId"] = new SelectList(modelsView, "ModelId", "Name", car.ModelId);


            var users = await this.userService.GetAllAsync();
            var usersView = new List<UserViewModel>();

            foreach (var user in users)
            {
                usersView.Add(new UserViewModel
                {
                    UserId = user.Id,
                    FirstName = user.FirstName,
                    LastName = user.LastName,
                    PhoneNumber = user.Phone,
                    Email = user.Email
                });
            }

            ViewData["OwnerId"] = new SelectList(usersView, "UserId", "Email", car.OwnerId);

            return View(car);
        }

        [HttpGet("Details/{id}")]
        [Authorize(Roles = "Admin, Customer")]
        public async Task<IActionResult> Details(int id)
        {
            var carDTO = await this.carService.GetAsync(id);

            var carDetailsView = new CarDetailsViewModel();

            var manufacturerName = this.manufacturerService.GetAsync(carDTO.ManufacturerId).Result.Name;

            var modelName = this.modelService.GetAsync(carDTO.ModelId).Result.Name;

            carDetailsView.CarId = carDTO.Id;
            carDetailsView.CarIDNumber = carDTO.VehicleIDNumber;
            carDetailsView.LicensePlate = carDTO.LicensePlate;
            carDetailsView.OwnerName = carDTO.OwnerName;
            carDetailsView.ManufacturerId = carDTO.ManufacturerId;
            carDetailsView.ManufacturerName = manufacturerName;
            carDetailsView.ModelId = carDTO.ModelId;
            carDetailsView.ModelName = modelName;
            carDetailsView.OwnerId = carDTO.UserId;
            carDetailsView.YearOfManufacture = carDTO.YearOfManufacture;
            carDetailsView.ServiceHistoryId = carDTO.ServiceHistoryId;

            return View(carDetailsView);
        }

        [HttpGet("UserCars/{id}")]
        [Authorize(Roles = "Admin, Customer")]
        public async Task<IActionResult> UserCars(int id)
        {
            var carDTOs = await this.carService.GetAllForCustomerAsync(id);
          
            var carsView = new List<CarViewModel>();

VirtualCarGarage/VirtualCarGarage/Controllers/UsersController.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using VirtualCarGarage.Data.Models;
using VirtualCarGarage.MVC.Models;
using VirtualCarGarage.Services.Contracts;
using VirtualCarGarage.Services.Models;

namespace VirtualCarGarage.MVC.Controllers
{
    [Route("[controller]")]
    [Authorize]
    public class UsersController : Controller
    {
        private readonly IUserService userService;
        private readonly UserManager<User> userManager;

        public UsersController(IUserService userService, UserManager<User> userManager)
        {
            this.userService = userService;
            this.userManager = userManager;
        }

        [HttpGet("Index")]
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Index()
        {
            var users = await this.userService.GetAllAsync();

            var usersView = new List<UserViewModel>();

            foreach (var user in users)
            {
                usersView.Add(new UserViewModel
                {
                    UserId = user.Id,
                    FirstName = user.FirstName,
                    LastName = user.LastName,
                    PhoneNumber = user.Phone,
                    Email = user.Email
                });
            }

            return await Task.FromResult(View(usersView));
        }

        [HttpGet("Create")]
        [Authorize(Roles = "Admin")]
        public IActionResult Create()
        {

            return View();
        }

        [HttpPost("Create")]
        [Authorize(Roles = "Admin")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create([Bind("Email,FirstName,LastName,PhoneNumber")] UserCreateViewModel model)
        {
            if (ModelState.IsValid)
            {
                var userDto = new UserDTO
                {
                    Email = model.Email,
                    FirstName = model.FirstName,
                    LastName = model.LastName,
                    Phone = model.PhoneNumber
                };
                var dto = await this.userService.CreateAsync(userDto);
                return RedirectToAction(nameof(Index));
            }
            return View(model);
        }

        [HttpGet("Edit/{id}")]
        [Authorize(Roles = "Admin, Customer")]
        public async Task<IActionResult> Edit(int id)
        {
            var user = await this.userService.GetAsync(id);

            var userView = new UserEditViewModel
            {
                UserId = user.Id,
                Email = user.Email,
                PhoneNumber = user.Phone,
                FirstName = user.FirstName,
                LastName = user.LastName
            };            

            return View(userView);

        }

        [HttpPost("Edit/{id}")]
        [ValidateAntiForgeryToken]
        [Authorize(Roles = "Admin, Customer")]
        public async Task<IActionResult> Edit(UserEditViewModel user)
        {

            if (ModelState.IsValid)
            {
                var userDTO = new UserDTO
                {
                    Id = user.UserId,
                    Email = user.Email,
                    Phone = user.PhoneNumber,
                    FirstName = user.FirstName,
                    LastName = user.LastName                    
                };
                var updated = await this.userService.UpdateAsync(userDTO);
                return RedirectToAction(nameof(Index));
            }
            
            return View(user);
        }

        [HttpGet("Delete/{id}")]
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Delete(int id)
        {
            var user = await this.userService.GetAsync(id);
            var userView = new UserViewModel
            {
                UserId = user.Id,
                Email = user.Email,
                PhoneNumber = user.Phone,
                FirstName = user.FirstName,
                LastName = user.LastName
            };

            return View(userView);
        }

        [HttpPost("Delete/{id}")]
        [ValidateAntiForgeryToken]
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Delete(UserViewModel user)
        {
            try
            {
                var result = await this.userService.DeleteAsync(user.UserId);

                return RedirectToAction(nameof(Index));
            }
            catch
            {
                return View();
            }
        }

        [HttpGet("Profile")]
        [Authorize(Roles = "Admin, Customer")]
        public async Task<IActionResult> Profile()
        {
            var user = await this.userManager.GetUserAsync(User);

            var userView = new UserEditViewModel()
            {
                UserId = user.Id,
                FirstName = user.FirstName,
                LastName = user.LastName,
                Email = user.Email,
                PhoneNumber = user.PhoneNumber
            };

            return View(userView);
        }

        [HttpPost("Profile")]
        [ValidateAntiForgeryToken]
        [Authorize(Roles = "Admin, Customer")]
        public async Task<IActionResult> Profile(UserEditViewModel user)
        {
            if(ModelState.IsValid)
            {
                var userDTO = new UserDTO
                {
                    Id = user.UserId,
                    Email = user.Email,
                    Phone = user.PhoneNumber,
                    FirstName = user.FirstName,
                    LastName = user.LastName
                };
                var updated = await this.userService.UpdateAsync(userDTO);
                return View();
            }

            return View(user);
        }

        [HttpGet("ChangePass")]
        [Authorize(Roles = "Admin, Customer")]
        public async Task<IActionResult> ChangePass()
        {
            var user = await this.userManager.GetUserAsync(User);

            var changePassView = new ChangePassViewModel()
            {
                UserId = user.Id,
                NewPassword = "",
                ConfirmPassword = ""
            };

            return View(changePassView);
        }

        [HttpPost("ChangePass")]
        [ValidateAntiForgeryToken]
        [Authorize(Roles = "Admin, Customer")]
        public async Task<IActionResult> ChangePass(ChangePassViewModel changePassViewModel)
        {
            if (!ModelState.IsValid)
            {
                return View();
            }

            var user = await userManager.GetUserAsync(User);
            if (user == null)
            {
                return NotFound($"Unable to load user with ID '{userManager.GetUserId(User)}'.");
            }
          
            var changePasswordResult = await userService.ChangePasswordAsync(user.Id, changePassViewModel.NewPassword, changePassViewModel.ConfirmPassword);
                    

            return View();
        }
    }
}

VirtualCarGarage/VirtualCarGarage/Views/Shared/_Layout.cshtml
@using Microsoft.AspNetCore.Identity
@using VirtualCarGarage.Data.Models

@inject SignInManager<User> SignInManager
@inject UserManager<User> UserManager

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - VirtualCarGarage</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" />
    <style>
        .footer {
            position: fixed;
            left: 0;
            bottom: 0;
            width: 100%;
            background-color: gray;
            color: white;
            text-align: center;
        }
    </style>
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container">
                <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex flex-sm-row-reverse">
                    <partial name="_LoginPartial" />
                    <ul class="navbar-nav flex-grow-1">
                        @if (SignInManager.IsSignedIn(User))
                        {
                            <li class="nav-item">
                                <a class="nav-link text-dark" asp-area="" asp-controller="Users" asp-action="Profile">MyProfile</a>
                            </li>

                            @if (User.IsInRole("Customer"))
                            {
                                <li class="nav-item">
                                    <a class="nav-link text-dark" asp-area="" asp-controller="Cars" asp-action="Index">MyCars</a>
                                </li>
                            }

                            @if (User.IsInRole("Admin"))
                            {
                                <li class="nav-item">
                                    <a class="nav-link text-dark" asp-area="" asp-controller="Cars" asp-action="Index">Cars</a>
                                </li>
                                <li class="nav-item">
                                    <a class="nav-link text-dark" asp-area="" asp-controller="Users" asp-action="Index">Customers</a>
                                </li>
                                <li class="nav-item">
                                    <a class="nav-link text-dark" asp-area="" asp-controller="Manufacturers" asp-action="Index">Manufacturers</a>
                                </li>
                                <li class="nav-item">
                                    <a class="nav-link text-dark" asp-area="" asp-controller="Models" asp-action="Index">Models</a>
                                </li>
                                <li class="nav-item">
                                    <a class="nav-link text-dark" asp-area="" asp-controller="Services" asp-action="Index">Services</a>
                                </li>
                                <li class="nav-item">
                                    <a class="nav-link text-dark" asp-area="" asp-controller="Orders" asp-action="Index">Orders</a>
                                </li>
                                <li class="nav-item">
                                    <a class="nav-link text-dark" asp-area="" asp-controller="ServiceHistories" asp-action="Index">ServiceHistories</a>
                                </li>
                            }}
                    </ul>
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>
    <footer id="footer" class="footer fixed-bottom">
        @if (SignInManager.IsSignedIn(User))
        {
            <div class="container">
                <div class="copyright">
                    &copy; 2021 - VirtualCarGarage - 
                </div>
            </div>
        }
        @if (!SignInManager.IsSignedIn(User))
        {
            <div class="container">
                <div class="copyright">
                    &copy; 2021 - VirtualCarGarage - <a asp-area="" asp-controller="Home" asp-action="CreateFromContactForm">Request Account</a>
                </div>
            </div>
        }
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @RenderSection("Scripts", required: false)
</body>
</html>